
/******************************************************************************
* MODULE     : string_append.cpp
* DESCRIPTION: Append strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
namespace mml {

void
string_rep::extend (nat d) {
  if (n+d > l) {
    register nat old_l= l;
    l= max (l << 1, n+d);
    char* b= (char*) mml_malloc (l);
    for (nat i=0; i<n; i++)
      b[i]= a[i];
    mml_free ((void*) a, old_l);
    a= b;
  }
  n += d;
}

string&
string::operator << (char x) {
  secure ();
  rep->extend (1);
  rep->a[rep->n-1]= x;
  return *this;
}

string&
string::operator << (const string& s) {
  register nat i, k1= rep->n, k2=N(s);
  secure ();
  rep->extend (k2);
  for (i=0; i<k2; i++)
    rep->a[i+k1]= s.rep->a[i];
  return *this;
}

string
operator * (const string& s1, const string& s2) {
  register nat i, n1=N(s1), n2=N(s2);
  string r (n1 + n2);
  for (i=0; i<n1; i++) r.rep->a[i   ]= s1.rep->a[i];
  for (i=0; i<n2; i++) r.rep->a[i+n1]= s2.rep->a[i];
  return r;
}

} // namespace mml
