
/******************************************************************************
* MODULE     : floating_test.cc
* DESCRIPTION: Test floating numbers
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rounded_floating.hpp"
using namespace mml;
#define Float floating<>

int
main () {
  Float x (1.0);
  set_precision (100);
  Float y (1.23456);
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "x+y\t= " << (x+y) << "\n";
  cout << "x-y\t= " << (x-y) << "\n";
  cout << "x*y\t= " << (x*y) << "\n";
  cout << "x/y\t= " << (x/y) << "\n";
  cout << "x+=y\t= " << (x+=y) << "\n";
  cout << "x-=y\t= " << (x-=y) << "\n";
  cout << "x*=y\t= " << (x*=y) << "\n";
  cout << "x/=y\t= " << (x/=y) << "\n";
  cout << "x<<3\t= " << (x<<3) << "\n";
  cout << "x>>3\t= " << (x>>3) << "\n";
  cout << "x<<=3\t= " << (x<<=3) << "\n";
  cout << "x>>=3\t= " << (x>>=3) << "\n";
  cout << "y^y\t= " << pow(y,y) << "\n";
  cout << "sqrt(y)\t= " << sqrt(y) << "\n";
  cout << "exp(x)\t= " << exp(x) << "\n";
  cout << "x=y\t= " << (x==y) << "\n";
  cout << "x!=y\t= " << (x!=y) << "\n";
  cout << "x<y\t= " << (x<y) << "\n";
  cout << "x<=y\t= " << (x<=y) << "\n";
  cout << "x>y\t= " << (x>y) << "\n";
  cout << "x>=y\t= " << (x>=y) << "\n\n";

  cout << "exp(1)\t\t= " << exp (Float (1)) << "\n";
  cout << "sqrt(2)\t\t= " << sqrt (Float (2)) << "\n";
  cout << "sqrt_D(2)\t= " << sqrt_D (Float (2)) << "\n";
  cout << "sqrt_U(2)\t= " << sqrt_U (Float (2)) << "\n";
  cout << "euler_D\t\t= " << Euler_D (Float) << "\n";
  cout << "euler_U\t\t= " << Euler_U (Float) << "\n";
  cout << "1_D\t\t= " << New_D (Float) (1) << "\n";
  cout << "1_U\t\t= " << New_U (Float) (1) << "\n";
  cout << "1.23_D\t\t= " << New_D (Float) (1.23) << "\n";
  cout << "1.23_U\t\t= " << New_U (Float) (1.23) << "\n";
  cout << "atan2(1,0)\t= " << atan2 (Float (1), Float(0)) << "\n";
  return 0;
}
