
/******************************************************************************
* MODULE     : complex_ball_impl.hpp
* DESCRIPTION: Standard complex balls
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MML_COMPLEX_BALL_HPP
#define __MML_COMPLEX_BALL_HPP
#include "real_ball_impl.hpp"
#include "complexify_ball.hpp"
namespace mml {
typedef complexify<real_ball_center> complex_ball_center;
typedef real_ball_radius complex_ball_radius;
#define Real_ball ball<real_ball_center,real_ball_radius>
#define Ball ball<complex_ball_center,complex_ball_radius>

class complex_ball {
MML_ALLOCATORS;
public:
  Ball rep;
  inline complex_ball (const Ball& x): rep (x) {}
  complex_ball (const complex_ball& x);
  ~complex_ball ();
  complex_ball& operator = (const complex_ball& x);
  complex_ball ();
  complex_ball (int i);
  complex_ball (nat i);
  complex_ball (double x);
  complex_ball (const integer& i);
  complex_ball (const rational& x);
  complex_ball (const real_ball_center& x);
  complex_ball (const complex_ball_center& z);
  complex_ball (const complex_ball_center& c, const complex_ball_radius& r);
  complex_ball (const real_ball& x, const real_ball& y= 0);
};

#undef Real_ball
#undef Ball
} // namespace mml
#endif // __MML_COMPLEX_BALL_HPP
