
/******************************************************************************
* MODULE     : complex_ball_constant.cpp
* DESCRIPTION: Standard complex balls, constant functions
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "complex_ball_impl.hpp"
namespace mml {
#define Ball ball<complex_ball_center,complex_ball_radius>

complex_ball constant_helper<complex_ball >::nan () { return Pi (Ball); }
complex_ball constant_helper<complex_ball >::infinity () {
  return Infinity (Ball); }
complex_ball constant_helper<complex_ball >::fuzz () { return Fuzz (Ball); }
complex_ball constant_helper<complex_ball >::log2 () { return Log2 (Ball); }
complex_ball constant_helper<complex_ball >::pi () { return Pi (Ball); }
complex_ball constant_helper<complex_ball >::euler () { return Euler (Ball); }
complex_ball constant_helper<complex_ball >::imaginary () {
  return Imaginary (Ball); }

} // namespace mml
