
/******************************************************************************
* MODULE     : real_ball.cpp
* DESCRIPTION: Standard real balls
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "real_ball_impl.hpp"
#include "floating.hpp"
#include "ball.hpp"
namespace mml {

real_ball::real_ball (const real_ball& x): rep (x.rep) {}
real_ball::~real_ball () {}
real_ball& real_ball::operator = (const real_ball& x) {
  rep= x.rep; return *this; }
real_ball::real_ball (): rep () {}
real_ball::real_ball (int i): rep (i) {}
real_ball::real_ball (nat i): rep (i) {}
real_ball::real_ball (double x): rep (x) {}
real_ball::real_ball (const integer& i): rep (i) {}
real_ball::real_ball (const rational& x): rep (x) {}
real_ball::real_ball (const real_ball_center& x): rep (copy (x)) {}
real_ball::real_ball (const real_ball_center& c, const real_ball_radius& r):
  rep (c, r) {}

WRAP_BASIC_IMPL(,real_ball);
WRAP_NUMBER_CHECK_IMPL(,real_ball);

generic as_generic (const real_ball& x, nat dd) {
  return as_generic (x.rep, dd); }
real_ball_center center (const real_ball& x) { return center (x.rep); }
real_ball_radius radius (const real_ball& x) { return radius (x.rep); }
real_ball_center lower (const real_ball& x) { return lower (x.rep); }
real_ball_center upper (const real_ball& x) { return upper (x.rep); }
real_ball_radius abs_D (const real_ball& x) { return abs_D (x.rep); }
real_ball_radius abs_U (const real_ball& x) { return abs_U (x.rep); }
real_ball_radius bnd_D (const real_ball& x) { return bnd_D (x.rep); }
real_ball_radius bnd_U (const real_ball& x) { return bnd_U (x.rep); }

} // namespace mml
