
/******************************************************************************
* MODULE     : numeric_polynomial_test.cc
* DESCRIPTION: Tests for numeric polynomials
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "complex_ball.hpp"
#include "numeric_polynomial.hpp"
using namespace mml;

//#define Real double
//#define Real floating<>
#define Real real_ball
#define Complex complex_ball
#define Polynomial polynomial<Complex >

int
main () {
  set_precision (64);
  Polynomial P= seq (Complex (1), Complex (5), Complex (2));
  P= P * q_difference (P, Complex (-1)) +
     Polynomial (Complex (Real (0.001)), 1);
  P= P*P;

  //P= P*P;
  //P= P*P;
  //P= P*P;
  //P= P + Polynomial (Complex (1000));
  cout << "P\t= " << P << "\n";
  cout << "r\t= " << lower_bound_roots (P) << "\n";
  cout << "r\t= " << lower_bound_roots (seg (P), dim (P), 10, 0) << "\n";
  cout << "m\t= " << minimum_disk (seg (P), dim (P), 0.1) << "\n";
  cout << "M\t= " << maximum_disk (seg (P), dim (P), 1.0) << "\n";
  cout << "R\t= " << maximum_real_part_disk (seg (P), dim (P), 1.0) << "\n";
  return 0;
}
