
/******************************************************************************
* MODULE     : generic_functions.hpp
* DESCRIPTION: Standard functions on generic expressions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

// Notice that generic_functions is included by base.hpp

#ifndef __GENERIC_FUNCTIONS_HPP
#define __GENERIC_FUNCTIONS_HPP
namespace mml {

generic comma ();
generic comma (const generic& g1, const generic& g2);
generic apply (const generic& f, const generic& args);
generic tuple (const generic& g);
generic vtuple (const generic& g);
generic sqtuple (const generic& g);

generic operator - (const generic& g1);
generic operator + (const generic& g1, const generic& g2);
generic operator - (const generic& g1, const generic& g2);
generic operator * (const generic& g1, const generic& g2);
generic operator / (const generic& g1, const generic& g2);
generic quo (const generic& g1, const generic& g2);
generic rem (const generic& g1, const generic& g2);
generic pow (const generic& g1, const generic& g2);

/* arithmetic with rudimentary simplifications */
generic negate (const generic& g1);
generic plus (const generic& g1, const generic& g2);
generic minus (const generic& g1, const generic& g2);
generic migrate_negate (const generic& g, nat maximal);
generic times (const generic& g1, const generic& g2, bool frac_flag= false);
generic over (const generic& g1, const generic& g2, bool frac_flag= false);
generic power (const generic& g1, const generic& g2, bool frac_flag= false);

} // namespace mml
#endif // __GENERIC_FUNCTIONS_HPP
