
/******************************************************************************
* MODULE     : vector_test.cc
* DESCRIPTION: Test vectors
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer.hpp"
#include "dense_vector.hpp"
using namespace mml;

#define C integer
#define Vector vector<C>

int
main () {
  Vector u= seq (C (5), C (7), C (9));
  Vector v (1, 10);
  Vector w= vec (C (2), C (3), C (5));
  cout << "u\t= " << u << "\n";
  cout << "v\t= " << v << "\n";
  cout << "w\t= " << w << "\n";
  vector<C,dense_vector<linear<naive_multiply,nat_value<10> > > > x(3);
  vector<C,dense_vector<linear<naive_multiply,nat_value<10> > > > y(7);
  x(3)= 5;
  y(8)= 3;
  cout << "x\t= " << x << "\n";
  cout << "y\t= " << y << "\n";
  cout << "copy(x)\t= " << copy (x) << "\n";
  cout << "-x\t= " << -x << "\n";
  cout << "x+x\t= " << x+x << "\n";
  cout << "x-x\t= " << x-x << "\n";
  cout << "x*x\t= " << x*x << "\n";
  cout << "2*x\t= " << 2*x << "\n";
  cout << "x*2\t= " << x*2 << "\n";
  //cout << "x/3\t= " << x/3 << "\n";
  cout << "x+=y\t= " << (x+=y) << "\n";
  cout << "x-=y\t= " << (x-=y) << "\n";
  cout << "x*=y\t= " << (x*=y) << "\n";
  cout << "x/=y\t= " << (x/=y) << "\n";
  cout << "x*=11\t= " << (x*=C(11)) << "\n";
  cout << "x/=11\t= " << (x/=C(11)) << "\n";
  cout << "x=y\t= " << (x==y) << "\n";
  cout << "x!=y\t= " << (x!=y) << "\n";
  cout << "x<y\t= " << (x<y) << "\n";
  cout << "x<=y\t= " << (x<=y) << "\n";
  cout << "x>y\t= " << (x>y) << "\n";
  cout << "x>=y\t= " << (x>=y) << "\n";
  cout << "sum(x)\t= " << big_add (x) << "\n";
  cout << "min(y)\t= " << big_min (y) << "\n";
  cout << "x...\t= " << iterate (x) << "\n";
  return 0;
}
